/*
 * Copyright © 2014 f35f22fan@gmail.com
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting documentation, and
 * that the name of the copyright holders not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no representations
 * about the suitability of this software for any purpose.  It is provided "as
 * is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 * OF THIS SOFTWARE.
 */

#ifndef MTL_GLOBAL_HXX_
#define MTL_GLOBAL_HXX_

#if defined _WIN32 || defined __CYGWIN__
	#define MTL_DSO_IMPORT_T __declspec(dllimport)
	#define MTL_DSO_EXPORT_T __declspec(dllexport)
	#define MTL_DSO_HIDDEN_T
#else
	#if __GNUC__ >= 4
		#define MTL_DSO_IMPORT_T __attribute__ ((visibility ("default")))
		#define MTL_DSO_EXPORT_T __attribute__ ((visibility ("default")))
		#define MTL_DSO_HIDDEN_T __attribute__ ((visibility ("hidden")))
	#else
		#define MTL_DSO_IMPORT_T
		#define MTL_DSO_EXPORT_T
		#define MTL_DSO_HIDDEN_T
	#endif
#endif

#endif
